Description

This is a guide on how | compile a kernel module for Raspbian on a Raspberry Pi 2.

Prepare the Environment

o Make sure the system is up to date:
apt—-get update && apt-get upgrade
e |nstall a few dependencies:

apt—-get install build-essential bc automake autoconf libtool gawk alien fakeroot zliblg-dev uu
id-dev libblkid-dev libselinux-dev parted lsscsi wget ncurses-dev

Download the Kernel

e Clone the latest raspberry pi toolchain:

cd /usr/src
git clone https://github.com/raspberrypi/tools

e Export the toolchain path:

export CCPREFIX=/usr/src/tools/arm-bcm2708/arm-bcm2708-1inux-gnueabi/bin/arm-bcm2708-1inux-gnu
eabi-

e Download the latest linux kernel for the raspberry pi:

cd /usr/src
git clone https://github.com/raspberrypi/linux

e Then checkout the current kernel version:

cd /usr/src/linux
zgrep "* firmware as of" /usr/share/doc/raspberrypi-bootloader/changelog.Debian.gz | head -1 |
awk '{ print $5 }' | git checkout -

® Then export the kernel source path:
export KERNEL_SRC=/usr/src/linux

Compile the Kernel Modules

e | oad the configs kernel module:
modprobe configs
® | oad the current config into the kernel source directory:
zcat /proc/config.gz > /usr/src/linux/.config
e Prepare the kernel build environment:

cd /usr/src/linux
make mrproper

e Use the previous kernel config with the new kernel build environment:
make oldconfig
e Build the kernel:
make -7j4
* Now use a make file that references the kernel source directory to built the kernel module only, use a line like:

PREFIX = /usr/src/tools/arm-bcm2708/arm-bcm2708-1inux—gnueabi/bin/arm-bcm2708-1inux-gnueabi-
make -C /usr/src/linux M=$ (SRC) modules

Resources

e http:/lostindetails.com/blog/post/Compiling-a-kernel-module-for-the-raspberry-pi-2
http://openstack.provi2n.com/openstack-on-raspberry-pi-part-2-getting-started/
https://raspberrypicloud.wordpress.com/2013/03/12/building-an-Ixc-friendly-kernel-for-the-raspberry-pi/
http://elinux.org/Raspberry Pi_Kernel Compilation

History

#1 - 10/27/2015 04:22 PM - Daniel Curtis
- Description updated

- % Done changed from 0 to 20

#2 - 10/27/2015 04:35 PM - Daniel Curtis

- Description updated

#3 - 10/27/2015 07:45 PM - Daniel Curtis

- Description updated

#4 - 10/27/2015 08:05 PM - Daniel Curtis

- Description updated
http://lostindetails.com/blog/post/Compiling-a-kernel-module-for-the-raspberry-pi-2
http://openstack.prov12n.com/openstack-on-raspberry-pi-part-2-getting-started/
https://raspberrypicloud.wordpress.com/2013/03/12/building-an-lxc-friendly-kernel-for-the-raspberry-pi/
http://elinux.org/Raspberry_Pi_Kernel_Compilation

#5 - 11/15/2015 06:11 PM - Daniel Curtis

- Subject changed from Compiling a Kernel Module on Raspbian to Compiling Kernel Modules on Raspbian
- Category set to Kernel Hacking

- Status changed from New to Resolved

- % Done changed from 20 to 100

- Estimated time changed from 5.00 h to 3.00 h

#6 - 11/27/2015 03:44 PM - Daniel Curtis

- Status changed from Resolved to Closed
